//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%46D850100281.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%46D850100281.cm

//## begin module%46D850100281.cp preserve=no
//## end module%46D850100281.cp

//## Module: AsciiChain%46D850100281; Package specification
//## Subsystem: XSFit::MCMC%41E6AA18032C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/MCMC/AsciiChain.h

#ifndef ASCIICHAIN_H
#define ASCIICHAIN_H 1

//## begin module%46D850100281.additionalIncludes preserve=no
//## end module%46D850100281.additionalIncludes

//## begin module%46D850100281.includes preserve=yes
//## end module%46D850100281.includes

// ChainIO
#include <XSFit/MCMC/ChainIO.h>

class Chain;

//## begin module%46D850100281.declarations preserve=no
//## end module%46D850100281.declarations

//## begin module%46D850100281.additionalDeclarations preserve=yes
#include <fstream>
//## end module%46D850100281.additionalDeclarations


//## begin AsciiChain%46DD7BF103B0.preface preserve=yes
//## end AsciiChain%46DD7BF103B0.preface

//## Class: AsciiChain%46DD7BF103B0
//## Category: XSFit::MCMC%41E6AB1C02FC
//## Subsystem: XSFit::MCMC%41E6AA18032C
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%46DDB8B10106;Chain { -> F}

class AsciiChain : public ChainIO  //## Inherits: <unnamed>%46DD7C75006B
{
  //## begin AsciiChain%46DD7BF103B0.initialDeclarations preserve=yes
  //## end AsciiChain%46DD7BF103B0.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: AsciiChain%46DDB8450345
      AsciiChain (string fileName = string(""));

    //## Destructor (generated)
      virtual ~AsciiChain();


    //## Other Operations (specified)
      //## Operation: doOpenForReadPoints%46DD86EE022E
      virtual void doOpenForReadPoints () const;

      //## Operation: doCloseFile%46DD86F5030D
      virtual void doCloseFile () const;

      //## Operation: doOpenForWrite%46DF24A10281
      virtual void doOpenForWrite ();

      //## Operation: doReadPoint%46DD86FB0383
      virtual void doReadPoint (std::vector<Real>& chainVals) const;

      //## Operation: doReadPointFromLine%46DD870302FF
      virtual void doReadPointFromLine (size_t lineNum, RealArray& parVals) const;

      //## Operation: getFormatName%46DDBF89013B
      virtual const string& getFormatName () const;

      //## Operation: readFileInfo%46DD90BA0181
      virtual void readFileInfo ();

      //## Operation: createFile%46DD90C302F7
      virtual void createFile ();

      //## Operation: writePoint%46DD90CD02AE
      virtual void writePoint ();

      //## Operation: writeFileInfo%46DD90DE00BC
      virtual void writeFileInfo ();

      //## Operation: adjustLengthInfo%46DD90E4028C
      virtual void adjustLengthInfo ();

      //## Operation: appendFile%46DD90F00283
      virtual void appendFile (RealArray& startingVals);

      //## Operation: adjustTemperInfo%46DD90F80225
      virtual void adjustTemperInfo ();

      //## Operation: checkTemperField%46DD9100005D
      virtual bool checkTemperField (const Real temperature) const;

      //## Operation: setParent%46DDB5070061
      virtual void setParent (Chain* chain);

      //## Operation: allowsTemper%46DF28BB03D3
      virtual bool allowsTemper () const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: FORMATNAME%46DDBAA30219
      static const string& FORMATNAME ();

    // Additional Public Declarations
      //## begin AsciiChain%46DD7BF103B0.public preserve=yes
      //## end AsciiChain%46DD7BF103B0.public

  protected:
    // Additional Protected Declarations
      //## begin AsciiChain%46DD7BF103B0.protected preserve=yes
      //## end AsciiChain%46DD7BF103B0.protected

  private:
    //## Constructors (generated)
      AsciiChain(const AsciiChain &right);

    //## Assignment Operation (generated)
      AsciiChain & operator=(const AsciiChain &right);


    //## Other Operations (specified)
      //## Operation: moveToLine%46DD90EA0157
      void moveToLine (const size_t lineNum) const;

      //## Operation: readTemperInfo%46DD91070313
      string readTemperInfo ();

      //## Operation: testFile%46DDC79103D1
      void testFile (const string& fileName) const;

    // Additional Private Declarations
      //## begin AsciiChain%46DD7BF103B0.private preserve=yes
      //## end AsciiChain%46DD7BF103B0.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: LENGTHFIELDWIDTH%46DD91C102CE
      //## begin AsciiChain::LENGTHFIELDWIDTH%46DD91C102CE.attr preserve=no  private: static const size_t {U} 14
      static const size_t s_LENGTHFIELDWIDTH;
      //## end AsciiChain::LENGTHFIELDWIDTH%46DD91C102CE.attr

      //## Attribute: TEMPERFIELDWIDTH%46DD920401EB
      //## begin AsciiChain::TEMPERFIELDWIDTH%46DD920401EB.attr preserve=no  private: static const int {U} 200
      static const int s_TEMPERFIELDWIDTH;
      //## end AsciiChain::TEMPERFIELDWIDTH%46DD920401EB.attr

      //## begin AsciiChain::FORMATNAME%46DDBAA30219.attr preserve=no  public: static const string {U} string("ascii")
      static const string s_FORMATNAME;
      //## end AsciiChain::FORMATNAME%46DDBAA30219.attr

      //## Attribute: file%46DD934202DE
      //## begin AsciiChain::file%46DD934202DE.attr preserve=no  private: std::fstream {UM} 
      mutable std::fstream m_file;
      //## end AsciiChain::file%46DD934202DE.attr

      //## Attribute: lengthInfoPos%46DD93DD039E
      //## begin AsciiChain::lengthInfoPos%46DD93DD039E.attr preserve=no  private: std::fstream::pos_type {U} 
      std::fstream::pos_type m_lengthInfoPos;
      //## end AsciiChain::lengthInfoPos%46DD93DD039E.attr

      //## Attribute: pointsStartPos%46DD940001A2
      //## begin AsciiChain::pointsStartPos%46DD940001A2.attr preserve=no  private: std::fstream::pos_type {U} 
      std::fstream::pos_type m_pointsStartPos;
      //## end AsciiChain::pointsStartPos%46DD940001A2.attr

      //## Attribute: temperInfoPos%46DD9423024A
      //## begin AsciiChain::temperInfoPos%46DD9423024A.attr preserve=no  private: std::fstream::pos_type {U} 
      std::fstream::pos_type m_temperInfoPos;
      //## end AsciiChain::temperInfoPos%46DD9423024A.attr

      //## Attribute: chain%46DDB51401E0
      //	Pointer to the Chain object which owns this object.
      //	This obviously must be a non-owning pointer or else it
      //	will be a circular dependency.
      //## begin AsciiChain::chain%46DDB51401E0.attr preserve=no  private: Chain* {U} 
      Chain* m_chain;
      //## end AsciiChain::chain%46DDB51401E0.attr

    // Additional Implementation Declarations
      //## begin AsciiChain%46DD7BF103B0.implementation preserve=yes
      //## end AsciiChain%46DD7BF103B0.implementation

};

//## begin AsciiChain%46DD7BF103B0.postscript preserve=yes
//## end AsciiChain%46DD7BF103B0.postscript

// Class AsciiChain 

//## Get and Set Operations for Class Attributes (inline)

inline const string& AsciiChain::FORMATNAME ()
{
  //## begin AsciiChain::FORMATNAME%46DDBAA30219.get preserve=no
  return s_FORMATNAME;
  //## end AsciiChain::FORMATNAME%46DDBAA30219.get
}

//## begin module%46D850100281.epilog preserve=yes
//## end module%46D850100281.epilog


#endif
